using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace P15_1
{

    public class Ball : gBaseClass
    {
        //   
        Rectangle scrBounds;
        // 
        public Vector2 speed;
        Random rand = new Random();
        public Ball(Game game, ref Texture2D _sprTexture,
            Vector2 _sprPosition, Rectangle _sprRectangle, int x_c, int y_c)
            : base(game, ref _sprTexture, _sprPosition, _sprRectangle, x_c, y_c)
        {
            speed = new Vector2(5, -5);
            scrBounds = new Rectangle(16, 0,
              game.Window.ClientBounds.Width - 16,
              game.Window.ClientBounds.Height);

        }

        //     
        void Check()
        {
            if (sprPosition.X < scrBounds.Left)
            {
                sprPosition.X = scrBounds.Left;
                RandomiseSpeed();
                speed.X *= -1;
            }
            if (sprPosition.X > scrBounds.Width - sprRectangle.Width)
            {
                sprPosition.X = scrBounds.Width - sprRectangle.Width;
                RandomiseSpeed();
                speed.X *= -1;
            }
            if (sprPosition.Y < scrBounds.Top)
            {
                sprPosition.Y = scrBounds.Top;
                RandomiseSpeed();
                speed.Y *= -1;
            }
            if (sprPosition.Y > scrBounds.Height - sprRectangle.Height)
            {
                this.Dispose();
            }

        }

        //    
        bool IsCollideWithObject(gBaseClass spr)
        {
            return (this.sprPosition.X + this.sprRectangle.Width > spr.sprPosition.X &&
                        this.sprPosition.X < spr.sprPosition.X + spr.sprRectangle.Width &&
                        this.sprPosition.Y + this.sprRectangle.Height > spr.sprPosition.Y &&
                        this.sprPosition.Y < spr.sprPosition.Y + spr.sprRectangle.Height);


        }
        //       
        //   -    ,  
        void RandomiseSpeed()
        {
            speed.Y += (float)((rand.NextDouble() - rand.NextDouble()) * 0.4);
            speed.X += (float)((rand.NextDouble() - rand.NextDouble()) * 0.4);
        }
        //   Brick1   
        void RandomiseSpeedB1()
        {
            speed.Y += (float)(0.5 * Math.Sign(speed.Y) * Math.Abs(((rand.NextDouble() - rand.NextDouble()))));
            speed.X += (float)(0.5 * Math.Sign(speed.X) * Math.Abs(((rand.NextDouble() - rand.NextDouble()))));
        }
        //  
        public void IsCollide()
        {
            gBaseClass FindObj = null;
            Bat FindedBat;
            foreach (gBaseClass spr in Game.Components)
            {
                if (IsCollideWithObject(spr))
                {
                    //    Brick1
                    if (spr.GetType() == (typeof(Brick1)))
                    {
                        //  
                        FindObj = spr;
                        // 
                        RandomiseSpeedB1();
                        // 
                        speed *= -1;
                    }
                    //    2
                    // 
                    if (spr.GetType() == (typeof(Brick2)))
                    {
                        speed *= -1;
                    }
                    //   
                    if (spr.GetType() == (typeof(Bat)))
                    {
                        FindedBat = (Bat)spr;
                        RandomiseSpeed();
                        //   
                        //    
                        if (FindedBat.direction)
                        {
                            speed.Y = Math.Abs(speed.Y);
                            speed.X = Math.Abs(speed.X);
                            speed *= -1;
                        }
                        //  
                        // 
                        else
                        {
                            speed.Y = Math.Abs(speed.Y);
                            speed.X = Math.Abs(speed.X);
                            speed.Y *= -1;
                        }


                    }

                }
            }
            //    Block1
            if (FindObj != null)
            {
                // 
                FindObj.Dispose();
                FindObj = null;
            }

        }

        public override void Update(GameTime gameTime)
        {

            //     
            this.sprPosition += this.speed;
            //   10 
            if (speed.Y > 10) speed.Y = (float)10;
            if (speed.Y < -10) speed.Y = (float)-10;
            if (speed.X > 10) speed.X = (float)10;
            if (speed.X < -10) speed.X = (float)-10;
            //   
            Check();
            //   
            IsCollide();
            base.Update(gameTime);
        }
    }
}